/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By: $B2#ED(B $BM5;W(B <y5t0964@students.chiba-u.ac.jp>
 */

/* This code is derived from X-VFlib's vffuncs.c */

/* Type1_16struct.h */

/*$Id: Type1_16struct.h,v 1.6 1998/03/30 20:26:23 elca Exp $*/

#ifndef _TYPE1_16STRUCT_H
#define _TYPE1_16STRUCT_H

#include "btree.h"
#include "tree.h"

typedef struct {
    CharInfoPtr charInfo;
    char *bitmap;
} CharInfoUnit, *CharInfoUnitPtr;

typedef struct {
    CharInfoUnitPtr unit;
    int n;
    int index;
    int bitmapSize;
} CharInfoPool, *CharInfoPoolPtr;

typedef struct _Type1_16Font {
	FontPtr font;

	int hbits, wbytes;
	double matrix[4]; /* $BJ8;z7A>uJQ499TNs(B
			     [ m[1] m[3] ]
			     [ m[2] m[4] ]
			   */

	char *fontname; /* $B%]%9%H%9%/%j%W%H%U%)%s%H$NL>A0(B */

	CharInfoPoolPtr pool;
	BTreePtr btree;
	nodeptr node_ptr; /* ghostscript $B$N4IM}(B */

	void (*convert)(
#if NeedNestedPrototypes
		struct _Type1_16Font * /* font */,
		char *                 /* p */
#endif
		);
} Type1_16Font, *Type1_16FontPtr;


#endif
