/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* tree.c ghostscript εưλ */
/* $Id: tree.c,v 1.2 1998/03/30 05:41:57 elca Exp $ */

#include "tree.h"

struct node nil;   /* ֿ: 2ʬڤνü򼨤õ˻Ȥ */
nodeptr root = &nil;

/* key Ͽ */
nodeptr insert(keytype key)
{
	int cmp;
	nodeptr *p, q;

	strcpy(nil.key, key);
	p = &root;
	while ((cmp = strcmp(key, (*p)->key)) != 0)
		if (cmp < 0) p = &((*p)->left );
		else         p = &((*p)->right);
	if (*p != &nil) return NULL; /* ǤϿƤ */
	if ((q = malloc(sizeof *q)) == NULL) {
		printf("malloc() failed at %s line %d\n", __FILE__, __LINE__);
		exit(EXIT_FAILURE);
	}
	strcpy(q->key, key);
	q->left = &nil; q->right = *p; *p = q;

	q->refcnt = 1;

	return q;
}

/* key  */
int delete(keytype key)
{
	int cmp;
	nodeptr *p, *q, r, s;

	strcpy(nil.key, key);
	p = &root;
	while ((cmp = strcmp(key, (*p)->key)) != 0)
		if (cmp < 0) p = &((*p)->left );
		else         p = &((*p)->right);
	if (*p == &nil) return 1; /*  */
	r = *p;
	if      (r->right == &nil) *p = r->left;
	else if (r->left  == &nil) *p = r->right;
	else {
		q = &(r->left);
		while ((*q)->right != &nil) q = &((*q)->right);
		s = *q; *q = s->left;
		s->left = r->left; s->right = r->right;
		*p = s;
	}
	free(r);
	return 0; /*  */
}

/* key 򸡺 */
nodeptr search(keytype key)
{
	int cmp;
	nodeptr p;

	strcpy(nil.key, key);
	p = root;
	while((cmp = strcmp(key, p->key)) != 0)
		if (cmp < 0) p = p->left;
		else         p = p->right;
	if (p != &nil) return p; /*  */
	else           return NULL; /*  */
}

/* 2ʬڤɽ */
void printtree(nodeptr p)
{
	static int depth = 0;

	if (p->left != &nil) {
		depth++; printtree(p->left); depth--;
	}
	printf("%*c%s\n", 5 * depth, ' ', p->key);
	if (p->right != &nil) {
		depth++; printtree(p->right); depth--;
	}
}

/* end */
