/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By: $B2#ED(B $BM5;W(B <y5t0964@students.chiba-u.ac.jp>
 */

/* $Id: metric.h,v 1.4 1998/04/01 09:37:57 elca Exp $ */

#ifndef _METRIC_H
#define _METRIC_H

int d_to_i(double d);
double fmin(double a, double b);
double fmin4(double a, double b, double c, double d);
double fmax(double a, double b);
double fmax4(double a, double b, double c, double d);
double computeWidth(double matrix[4]);
double computeHeight(double matrix[4]);
double computeChWidth(double matrix[4]);
double computeChHeight(double matrix[4]);
double computeXdelta(double matrix[4]);
double computeYdelta(double matrix[4]);

#endif
