/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By: $B2#ED(B $BM5;W(B <y5t0964@students.chiba-u.ac.jp>
 */

/* string_ut.c */

/* $Id: string_ut.c,v 1.4 1998/03/26 15:02:16 elca Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Type1_16.h"

/*#define dprintf(str) fprintf str */
#define dprintf(str) /* */

/* $BBgJ8;z!">.J8;z$N0c$$$rL5;k$9$k(B strstr() */
char * strcasestr(char *haystack, const char *needle)
{
	int haystacklen, needlelen;
	char *haystackbuf;
	char *needlebuf;
	int i;
	char *ptr;
	char *ret;

	haystacklen = strlen(haystack);
	needlelen = strlen(needle);

	haystackbuf = (char *)malloc(haystacklen + 1);
	needlebuf = (char *)malloc(needlelen + 1);
	if(haystackbuf == NULL || needlebuf == NULL) {
		free(haystackbuf);
		free(needlebuf);
		return NULL;
	}


	strcpy(haystackbuf, haystack);
	strcpy(needlebuf, needle);

	for(i = 0; i < haystacklen; i++) {
		haystackbuf[i] = (char)tolower(haystackbuf[i]);
	}
	for(i = 0; i < needlelen; i++) {
		needlebuf[i] = (char)tolower(needlebuf[i]);
	}

	ptr = strstr(haystackbuf, needlebuf);

	if(ptr == NULL) {
		ret = NULL;
	} else {
		ret = (ptr - haystackbuf) + haystack;
	}

	dprintf((stdout, "hay %s->%s, need %s->%s, ret %d\n",
		 haystack, haystackbuf,
		 needle, needlebuf, ret));

	free(haystackbuf);
	free(needlebuf);

	return ret;
}

/* end */
